// global vars
var xml_request;
var previousStartNumField;
var nextStartNumField;
var urls;
var animating=false; // flags whether or not anything is animating
                     //  like the search screen dropping down.
// which side is up
var FRONT_MAIN     = 0;
var BACK_DIRECTORY = 1;
var HELP           = 2;
var face = FRONT_MAIN;
// need to track if the search menu is down
var searchDown=false;
// widget software version number
var VERSION=2.0;

function checkCR(evt){

  var evt = (evt) ? evt : ((event) ? event : null);
  var node = (evt.target) ? evt.target : ((evt.srcElement) ? evt.srcElement : null);

  if ((evt.keyCode == 13) && (node.type=="text")) {
    networkKey = document.key_form.input_key.value;

    JiWirePlugin.setNetworkName(networkName);
    JiWirePlugin.setNetworkKey(networkKey);
    var joinValue=JiWirePlugin.joinNetworkWithWEP();
    if(joinValue=="Success"){
      document.getElementById("key_entry").style.display = "none";
      document.getElementById("front_main").style.filter = "alpha(opacity:100)";
      document.getElementById("front_main").style.opacity = "1.0";
    } else {
      document.getElementById("key_entry").style.display = "none";
      document.getElementById("key_entry_error").style.display = "block";
    }
    return;
  }
}

function keyError() {
      document.getElementById("key_entry_error").style.display = "none";
      document.getElementById("front_main").style.filter = "alpha(opacity:100)";
      document.getElementById("front_main").style.opacity = "1.0";
}

function networkConnect(name) {
    networkName = name;
    JiWirePlugin.setNetworkName(networkName);
    JiWirePlugin.joinNetwork();
}

function networkConnectWEP(name) {
    networkName = name;
    document.key_form.input_key.focus();
    document.getElementById("key_entry").style.display = "block";
    document.getElementById("front_main").style.filter = "alpha(opacity:30)";
    document.getElementById("front_main").style.opacity = ".30";
    document.onkeypress = checkCR;
}

function runScan() {
    if(face==FRONT_MAIN && animating==false){
        if( JiWirePlugin ) { 
            var scanHtml = JiWirePlugin.getScan();
            var snifferResults = document.getElementById("snifferResults");
            snifferResults.innerHTML = scanHtml;
        }   
        calculateAndShowThumb("scrollContentFront","scrollBarFront","scrollThumbFront","scrollTrackFront");
    }
}   


function loaded() {
    if( JiWirePlugin ) {
        JiWirePlugin.logMessage("JiWire widget is starting up...");
        runScan();
        initializeWidget();
        var scanTimer = setInterval("runScan();", 5000);
    }
}

// Animation
function enterflip(event)
{
    document.getElementById("flip_over").style.display = "block";
}

function exitflip(event)
{
    document.getElementById("flip_over").style.display = "none";
}

function mousemove (event)
{
	if (!flipShown)
	{
		if (flipAnimation.timer != null)
		{
			clearInterval (flipAnimation.timer);
			flipAnimation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13;
		flipAnimation.duration = 500;
		flipAnimation.starttime = starttime;
		flipAnimation.element = document.getElementById ('flip');
		flipAnimation.timer = setInterval ("flipAnimate();", 13);
		flipAnimation.from = flipAnimation.now;
		flipAnimation.to = 1.0;
		flipAnimate();
		flipShown = true;
	}
}

function mouseexit (event)
{
	if (flipShown)
	{
		if (flipAnimation.timer != null)
		{
			clearInterval (flipAnimation.timer);
			flipAnimation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13;
		flipAnimation.duration = 500;
		flipAnimation.starttime = starttime;
		flipAnimation.element = document.getElementById ('flip');
		flipAnimation.timer = setInterval ("flipAnimate();", 13);
		flipAnimation.from = flipAnimation.now;
		flipAnimation.to = 0.0;
		flipAnimate();
		flipShown = false;
	}
}
var flipAnimation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};
var flipShown = false;

function flipAnimate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-flipAnimation.starttime, 0, flipAnimation.duration);
	if (T >= flipAnimation.duration)
	{
		clearInterval (flipAnimation.timer);
		flipAnimation.timer = null;
		flipAnimation.now = flipAnimation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / flipAnimation.duration));
		flipAnimation.now = computeNextFloat (flipAnimation.from, flipAnimation.to, ease);
	}
	flipAnimation.element.style.opacity = flipAnimation.now;
}

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}

function doFlip(front,back)
{
	if (window.widget)
                widget.prepareForTransition("ToBack");
        front.style.display="none";
        back.style.display="block";
        if (window.widget)
                setTimeout ('widget.performTransition();', 0);
}

function dropMenu(menu,position)
{
	menu.style.top=position;
}

function frontDirectoryToggle(event)
{
	if(searchDown)
	{
		frontClose(event);
	}
	else
	{
  		frontOpen(event);
	}
}

function frontClose(event)
{
        animating=true;
	var directory = document.getElementById("front_directory");
        directory.style.zIndex=-1;
        var i = 0;
        var delay=25;
        var counter=0;
        for(i=-110;i>-330;i=i-5)
	{
                counter++;
		var id=setTimeout('document.getElementById("front_directory").style.top="'+i+' px";',(counter*delay));
	}
        setTimeout('document.getElementById("front_directory").style.display="none";',(counter*delay));
	searchDown=false;
        animating=false;
        return counter*delay;
}
function frontOpen(event)
{
        animating=true;
        var directory = document.getElementById("front_directory");
        directory.style.display="block";
        directory.style.top="-332 px";
        directory.style.zIndex=-1;
        var counter=0;
        var delay=25;
        var i = 0;
        for(i=-333;i<-112;i=i+5)
        {
                counter++;
                var id=setTimeout('document.getElementById("front_directory").style.top="'+i+' px";',(counter*delay));
        }
        setTimeout('document.getElementById("front_directory").style.zIndex="9";',(counter*delay));
        searchDown=true;
        animating=false;
	return counter*delay;
}

function frontSearch(event){
        document.search_form.startnum.value = 0;
        var front = document.getElementById("front_main");
        var back = document.getElementById("back_directory");
        face=BACK_DIRECTORY;
        doFlip(front,back);
        var menu=document.getElementById("front_directory");
        menu.style.display="none";
	executeSearch();
}

function backDirDone(event)
{               
        var front = document.getElementById("back_directory");
        var back = document.getElementById("front_main");
        face=FRONT_MAIN;
        doFlip(front,back);
	if(searchDown){
		var menu=document.getElementById("front_directory");
	        menu.style.display="block";
		menu.style.top="-112";
	}
}        

function backHelpDone(event)
{
        var front = document.getElementById("back_help");
        var back = document.getElementById("front_main");
        face=FRONT_MAIN;
        doFlip(front,back);
}

function showPrefs(event)
{
	if(searchDown){
       		var time=frontClose(event);
                face=HELP; 
		setTimeout('doFlip(document.getElementById("front_main"),document.getElementById("back_help"))',10+time);
        } else {
		var front = document.getElementById("front_main");
		var back = document.getElementById("back_help");
                face=HELP; 
       	 	doFlip(front,back);
	}
}



// Forms
function clearPreferences()
{
  var x = "";
  widget.setPreferenceForKey("true", "no_promos");
  widget.setPreferenceForKey("0", "location_type_id");
  widget.setPreferenceForKey("0", "technology_id");
  widget.setPreferenceForKey("0", "provider_id");
  widget.setPreferenceForKey("both", "pay_free");
  widget.setPreferenceForKey("1 Infinite Loop", "address");
  widget.setPreferenceForKey("95014", "zip");
  widget.setPreferenceForKey("California", "state");
  widget.setPreferenceForKey("1", "country_id");
  widget.setPreferenceForKey("Cupertino", "city");
  widget.setPreferenceForKey("5.0", "radius");
  widget.setPreferenceForKey("0", "geocode_index");
  widget.setPreferenceForKey("0", "startnum");
}

function selectCountry(countryId){
  //loop through the country list and select the country
  var countryList=document.getElementById("w12_list_country");
  var currentId=0;
  var currentName="";
  for(var i=0;i<countryList.options.length;i++){
    currentId=countryList.options[i].value;
    currentName=countryList.options[i].text;
    if(currentId==countryId){
      document.getElementById ('w12_text_country_label').innerText =currentName;
    }
  }
}

function selectProximity(proximity){
  //loop through the proximity list and select the proximity
  var proximityList=document.getElementById("w12_list_proximity");
  var currentId=0;
  var currentText="";
  for(var i=0;i<proximityList.options.length;i++){
    currentId=proximityList.options[i].value;
    currentText=proximityList.options[i].text;
    if(currentId==proximity){
      document.getElementById ('w12_text_proximity_label').innerText =currentText;
    }
  }
}

function initializeWidget()
{
  //get new version link
  getVersionUpdateLink();

  var f = document.search_form;
  // override the form to the last saved search

  if( widget.preferenceForKey("no_promos") != undefined ) {
    f.no_promos.value = widget.preferenceForKey("no_promos");
  } if( widget.preferenceForKey("location_type_id") != undefined ) {
    f.location_type_id.value = widget.preferenceForKey("location_type_id");
  } if( widget.preferenceForKey("technology_id") != undefined ) {
    f.technology_id.value = widget.preferenceForKey("technology_id");
  } if( widget.preferenceForKey("provider_id") != undefined ) {
    f.provider_id.value = widget.preferenceForKey("provider_id");
  }

  if( widget.preferenceForKey("pay_free") != undefined ) {
    f.pay_free.value = widget.preferenceForKey("pay_free");
    selectRadio(widget.preferenceForKey("pay_free"));
  }  else {
    f.pay_free.value = "both";
    selectRadio("both");
  }

  if( widget.preferenceForKey("address") != undefined ) {
    f.address.value = widget.preferenceForKey("address");
  } else {
    f.address.value = "1 Infinite Loop";
  }

  if( widget.preferenceForKey("zip") != undefined ) {
    f.zip.value = widget.preferenceForKey("zip");
  } else {
    f.zip.value = "95014";
  }

  if( widget.preferenceForKey("state") != undefined ) {
    f.state.value = widget.preferenceForKey("state");
  } else {
    f.state.value = "California";
  }

  if( widget.preferenceForKey("country_id") != undefined ) {
    f.country_id.value = widget.preferenceForKey("country_id");
    selectCountry(widget.preferenceForKey("country_id"));
  } else {
    f.country_id.value = "1";
    selectCountry("1");
  }

  if( widget.preferenceForKey("city") != undefined ) {
    f.city.value = widget.preferenceForKey("city");
  } else {
    f.city.value = "Cupertino";
  }

  if( widget.preferenceForKey("radius") != undefined ) {
    f.radius.value = widget.preferenceForKey("radius");
    selectProximity(widget.preferenceForKey("radius"));
  } else {
    f.radius.value = "5.0";
    selectProximity("5.0");
  }

  if( widget.preferenceForKey("geocode_index") != undefined ) {
    f.geocode_index.value = widget.preferenceForKey("geocode_index");
  }

  if( widget.preferenceForKey("startnum") != undefined ) {
    f.startnum.value = widget.preferenceForKey("startnum");
  }

}

// retrieve text of an XML document element, including
// elements using namespaces

function getElementTextNS(prefix, local, parentElem, index) {
    var result = "";

    if (prefix && isIE) {
        // IE/Windows way of handling namespaces
        result = parentElem.getElementsByTagName(prefix + ":" + local)[index];
    } else {
        // the namespace versions of this method
        // (getElementsByTagNameNS()) operate
        // differently in Safari and Mozilla, but both
        // return value with just local name, provided
        // there aren't conflicts with non-namespace element
        // names
        result = parentElem.getElementsByTagName(local)[index];
    }

    if (result) {
        // get text, accounting for possible
        // whitespace (carriage return) text nodes
        if (result.childNodes.length > 1) {
            return result.childNodes[1].nodeValue;
        } else {
            if( result.childNodes.length == 0 )
              return "";
            else
              return result.firstChild.nodeValue;
        }
    } else {
        return "n/a";
    }
}


function executeSearch()
{
  var f = document.search_form;
  var query = "http://www.jiwire.com/apple-widget-search.htm";
  // check to see if the minimum search requirements
  // have been met  
  var results = document.getElementById("results");
  if( (f.address.value.length < 2) && (f.zip.value.length < 2) && (f.city.value.length < 2) )
  {
    results.innerHTML = '<div id="loading">Please be more specific in your search.</div>';
    document.getElementById("w22_pagination").innerHTML = "";
    document.getElementById("w22_go_next").innerHTML="";
    document.getElementById("w22_go_prev").innerHTML="";
    calculateAndShowThumb("scrollContentBack","scrollBarBack","scrollThumbBack","scrollTrackBack");
    return;
  }
  query = query + "?search=true";
  query = query + "&no_promos=" + f.no_promos.value;
  query = query + "&location_type_id=" + f.location_type_id.value;
  query = query + "&technology_id=" + f.technology_id.value;
  query = query + "&provider_id=" + f.provider_id.value;
  query = query + "&pay_free=" + f.pay_free.value;
  query = query + "&address=" + f.address.value;
  query = query + "&zip=" + f.zip.value;
  query = query + "&state=" + f.state.value;
  query = query + "&country_id=" + f.country_id.value;
  query = query + "&city=" + f.city.value;
  query = query + "&radius=" + f.proximity.value;
  query = query + "&geocode_index=" + f.geocode_index.value;
  query = query + "&startnum=" + f.startnum.value;
  // save for later

  widget.setPreferenceForKey(f.no_promos.value, "no_promos");
  widget.setPreferenceForKey(f.location_type_id.value, "location_type_id");
  widget.setPreferenceForKey(f.technology_id.value, "technology_id");
  widget.setPreferenceForKey(f.provider_id.value, "provider_id");
  widget.setPreferenceForKey(f.pay_free.value, "pay_free");
  widget.setPreferenceForKey(f.address.value, "address");
  widget.setPreferenceForKey(f.zip.value, "zip");
  widget.setPreferenceForKey(f.state.value, "state");
  widget.setPreferenceForKey(f.country_id.value, "country_id");
  widget.setPreferenceForKey(f.city.value, "city");
  widget.setPreferenceForKey(f.proximity.value, "radius");
  widget.setPreferenceForKey(f.geocode_index.value, "geocode_index");
  widget.setPreferenceForKey(f.startnum.value, "startnum");
  //results.innerHTML = '<div id="loading">' + query + '</div>';
  //return;
  // clear out results
  results.innerHTML = '<div id="loading">Loading...</div>';
  //jwAlert("query: " + query);

  xml_request = new XMLHttpRequest();
  
  xml_request.onreadystatechange = processReqChange;
  // asyncronous request
  // using POST because GET had unpredicatable results...
  xml_request.open("POST", query, true);
  xml_request.send(null);
}

function URLDecode(str)
{
  var lsRegExp = /\+/g;
  return unescape(String(str).replace(lsRegExp, " "));
}


function processReqChange() {
  var results = document.getElementById("results");
  if( xml_request.readyState == 4) {
    if( xml_request.status == 200) {
      //jwAlert("got response!");
      var pagination = document.getElementById("w22_pagination");
      var summary = xml_request.responseXML.getElementsByTagName("summary");
      var startNumField = getElementTextNS("", "startnum", summary[0], 0);
      var searchType = getElementTextNS("", "search_type", summary[0], 0);

      // these are global
      previousStartNumField = getElementTextNS("", "previous_startnum", summary[0], 0);
      nextStartNumField = getElementTextNS("", "next_startnum", summary[0], 0);

      // hide the previous and next links
      var pageBack = document.getElementById("pageback");
      var pageForward = document.getElementById("pageforward");

      if( previousStartNumField <= 0 )
      {
        document.getElementById("w22_go_prev").innerHTML='<img id="w22_page-back" src="images/w22-arrow-left-disabled.png">';
      }
      else
      {
        document.getElementById("w22_go_prev").innerHTML='<a href="javascript:goPrevious();"><img id="w22_page-back" src="images/w22-arrow-left.png"></a>';
      }

      if( nextStartNumField <= 0 )
      {
        document.getElementById("w22_go_next").innerHTML='<img id="w22_page-forward" src="images/w22-arrow-right-disabled.png">';
      }
      else
      {
        document.getElementById("w22_go_next").innerHTML='<a href="javascript:goNext();"><img id="w22_page-forward" src="images/w22-arrow-right.png"></a>';
      }

      var maxNumField = getElementTextNS("", "maxnum", summary[0], 0);
      var numResultsField = getElementTextNS("", "numresults", summary[0], 0);
      var locations = xml_request.responseXML.getElementsByTagName("location");

      //jwAlert(xml_request.responseText);
      //jwAlert(locations.length);
      var r = "";
      urls = new Array(locations.length);

      var flipField = "roweven" // or rowodd
      var flipCounter=0;
      for(var i=0; i< locations.length; i++) {
        var distanceField = getElementTextNS("", "distance", locations[i], 0);
        var unitField = getElementTextNS("", "unit", locations[i], 0);
        var nameField = getElementTextNS("", "name", locations[i], 0);
        var addressField = getElementTextNS("", "address", locations[i], 0);
        var cityField = getElementTextNS("", "city", locations[i], 0);
        var stateField = getElementTextNS("", "state", locations[i], 0);
        var zipField = getElementTextNS("", "zip", locations[i], 0);
        var countryCodeField = getElementTextNS("", "country_code", locations[i], 0);
        var urlField = getElementTextNS("", "jiwire_url", locations[i], 0);
        urls[i] = URLDecode(urlField);
        var providerField = getElementTextNS("", "provider", locations[i], 0);
        var adFlag = getElementTextNS("", "ad_flag_v2", locations[i], 0);
        var adTitle = getElementTextNS("", "ad_title_v2", locations[i], 0);
        var adBlurb = getElementTextNS("", "ad_blurb_v2", locations[i], 0);
        var adLinkText = getElementTextNS("", "ad_link_text_v2", locations[i], 0);
        var adName = getElementTextNS("", "ad_name_v2", locations[i], 0);
        
        if(adFlag == "true"){
          if(adTitle != "n/a"){
            if(flipCounter%2 == 1) flipField="rowodd";
            else flipField="roweven";
            flipCounter++;
            r = r + '      <div class="results_' + flipField + '"> ';
            r = r + '        <div class="results_column1"> ';
            r = r + '          <a href="javascript: openJiwire(' + i + ');"><img ';
            r = r + '            src="images/w22-icon-plus.png" ';
            r = r + '           title="More Information" class="results_moreicon"></a>';
            r = r + '        </div> ';
            r = r + '        <div class="results_wrap4">';
            r = r + '          <div class="results_text4"><span class="results_promo_text">'+URLDecode(adTitle)+'</span></div>';
            r = r + '          <div class="results_text4">'+URLDecode(adBlurb) + '</div>';
            r = r + '          <div class="results_text4"><a href="javascript: openJiwire(' + i + ');" target="_blank" class="results_promo_link">'+adLinkText+'</a></div>'; 
            r = r + '        </div>';  
            r = r + '      </div>';
          } 
        } else {
            if(flipCounter%2 == 1) flipField="rowodd";
            else flipField="roweven";
            flipCounter++;
            r = r + '      <div class="results_' + flipField + '"> ';
            r = r + '        <div class="results_column1"> ';
            r = r + '          <a href="javascript: openJiwire(' + i + ');"><img ';
            r = r + '            src="images/w22-icon-plus.png" ';
            r = r + '           title="More Information" class="results_moreicon"></a>';
            r = r + '        </div> ';
            r = r + '        <div class="results_column2"> ';
            r = r + '          <div class="results_wrap1"><div class="results_text1">' + URLDecode(nameField) + '</div></div> ';
            r = r + '          <div class="results_wrap1"><div class="results_text1">' + URLDecode(addressField) + '</div></div> ';
            r = r + '          <div class="results_wrap1"><div class="results_text1">' + URLDecode(cityField);
            r = r + ' ' + URLDecode(zipField) +  '</div></div> ';
            r = r + '        </div>';
            r = r + '        <div class="results_column3">';
            r = r + '          <div class="results_wrap2">';
            r = r + '            <div class="results_miles">';

            if( searchType == 'centroid' )
            {
              r = r + URLDecode(distanceField) + ' ' + URLDecode(unitField) + ' ';
            }
            r = r + '            </div>';
            r = r + '            <div class="results_map">';
            r = r + '                <a href="javascript: openJiwire(' + i + ');" title="View Map" target="_blank" class="results_map_link">Map</a>';
            r = r + '            </div> ';
            r = r + '          </div>';
            r = r + '          <div class="results_wrap3"><div class="results_text2">' + URLDecode(providerField) + '</div></div>';
            r = r + '        </div> ';
            r = r + '      </div> ';
        }
      }

      if( locations.length == 0 )
      {
        results.innerHTML = '<div id="loading">No results found.  Please try again.</div>';
        pagination.innerHTML = "";
        document.getElementById("w22_go_next").innerHTML="";
        document.getElementById("w22_go_prev").innerHTML="";
      }
      else
      { 
        results.innerHTML = r;
        pagination.innerHTML = startNumField + '-' + maxNumField + ' of ' + numResultsField;
      }
    } else {
      jwAlert("error getting XML data: " + xml_request.statusText);
      results.innerHTML = '<div id="loading">Unable to load results.  Are you online?</div>';
    }
  }
  
  calculateAndShowThumb("scrollContentBack","scrollBarBack","scrollThumbBack","scrollTrackBack");
}


function goPrevious()
{   
  document.search_form.startnum.value = previousStartNumField;
  executeSearch();
} 

function goNext()
{   
  document.search_form.startnum.value = nextStartNumField;
  executeSearch();
} 

function selectRadio(payFree){
  for (var i = 0 ; i < document.images.length; i++)
  {
     if (document.images[i].value == payFree)
     {
       document.images[i].src = (document.images[i].value == payFree)  ?  'images/w12-radio-selected.png': 'images/w12-radio.png'
     }
  }

}

function imageRadiosFront(imgRadObj)
{
  var cell = imgRadObj.value;
  document.search_form.pay_free.value=cell; 
  for (var i = 0 ; i < document.images.length; i++)
  {
     if (document.images[i].name == imgRadObj.name)
     {
       document.images[i].src = (document.images[i].value == cell)  ?  'images/w12-radio-selected.png': 'images/w12-radio.png'
     }
  }
  document.search_form.startnum.value = 0; 
/*  executeSearch(); */
}

function imageRadiosBack(imgRadObj)
{
  var cell = imgRadObj.value;
  document.search_form.pay_free.value=cell; 
  for (var i = 0 ; i < document.images.length; i++)
  {
     if (document.images[i].name == imgRadObj.name)
     {
       document.images[i].src = (document.images[i].value == cell)  ?  'images/w22-radio-selected.png': 'images/w22-radio.png'
     }
  }
  document.search_form.startnum.value = 0; 
  executeSearch(); 
}

function countryChanged (select)
{
	var defaultCountry;
	if (defaultCountry != select.selectedIndex)
	{
		defaultCountry = select.selectedIndex;
		document.getElementById ('w12_text_country_label').innerText = document.getElementById ('w12_list_country').options[defaultCountry].text;
	}
}

function stateChanged (select)
{
	var defaultState;
	if (defaultState != select.selectedIndex)
	{
		defaultState = select.selectedIndex;
		document.getElementById ('w12_text_state_label').innerText = document.getElementById ('w12_list_state').options[defaultState].text;
	}
}

function proximityChanged (select)
{
	var defaultProximity;
	if (defaultProximity != select.selectedIndex)
	{
		defaultProximity = select.selectedIndex;
		document.getElementById ('w12_text_proximity_label').innerText = document.getElementById ('w12_list_proximity').options[defaultProximity].text;
	}
}


// Scroll Bar
	var currentContent;
	var currentContentStyle;
	var scrollThumb;
	var trackTimer;
	var currentContentHeight;
	var currentContentTop;
	var viewHeight;
	var trackMouseY;
	var thumbHeight;
	var tracking					= true;
	var thumbStartY					= -1;
	var scrollThumbStartPos			= -1;
	var scrollBarHeight;
	var numberOfScrollablePixels;
	var SCROLLBAR_TOP		= -1;
	var SCROLL_THUMB_HEIGHT	= 27;

function calculateAndShowThumb(contentDivName,scrollBarDivName,scrollThumbDivName,scrollBarTrackDivName) {
	currentContent = document.getElementById(contentDivName);
	currentContent.style.display = 'block';
	currentContentStyle = document.defaultView.getComputedStyle(currentContent,'');
		DEBUG("cast: cct=" + currentContentStyle.getPropertyValue('top'));
	currentContentTop = parseInt(currentContentStyle.getPropertyValue('top'));
	currentContentHeight = parseInt(currentContentStyle.getPropertyValue('height'));

	viewHeight = parseFloat (document.defaultView.getComputedStyle(currentContent.parentNode, '').getPropertyValue('height'));
		DEBUG("cast: viewHeight=" + viewHeight);
	var bar	= document.getElementById(scrollBarDivName);
	var barTrack = document.getElementById(scrollBarTrackDivName);
	scrollBarHeight = parseInt(document.defaultView.getComputedStyle(bar, '').getPropertyValue('height'));
		DEBUG("cast: currentContentHeight=" + currentContentHeight + " top=" + currentContentTop + " scrollBarHeight=" + scrollBarHeight);
	var percent = getProportion (viewHeight, currentContentHeight);
		DEBUG("cast: percent=" + percent);
	scrollThumb = document.getElementById(scrollThumbDivName);

        // set to top of page
        scrollThumb.style.top = SCROLLBAR_TOP + 'px';
        currentContentTop = pagePositionForThumbPosition(SCROLLBAR_TOP);
        currentContent.style.top = currentContentTop + 'px';

	if (percent == 0) {
		scrollThumb.style.display = 'none';
                barTrack.style.display='none';
	} else {
                barTrack.style.display='block';
		thumbHeight = Math.max(Math.round(scrollBarHeight * percent), SCROLL_THUMB_HEIGHT);
 
		scrollThumb.style.display = 'block';
		scrollThumb.style.height = thumbHeight + 'px';
		numberOfScrollablePixels = scrollBarHeight - thumbHeight - SCROLLBAR_TOP;
			DEBUG("cast: new thumb height=" + scrollThumb.style.height);
		scrollThumb.style.top = thumbPositionForPagePosition(currentContentTop);
	}
}

function mouseDownScrollThumb (event) {
	document.addEventListener("mousemove", mouseMoveScrollThumb, true);
	document.addEventListener("mouseup", mouseUpScrollThumb, true);
	thumbStartY = event.y;
	scrollThumbStartPos = parseInt(document.defaultView.getComputedStyle(scrollThumb,'').getPropertyValue('top'));
		DEBUG("mdThumbHeight:" + thumbHeight + " thumbStartY=" + thumbStartY);
}

function mouseMoveScrollThumb (event) {
	var deltaY = event.y - thumbStartY;
	var newPosition = scrollThumbStartPos + deltaY;
		DEBUG("mmst: event.y=" + event.y + " thumbStartY=" + thumbStartY + " thumbStart=" + scrollThumbStartPos);
	scrollContent(newPosition);
}


function mouseDownScrollThumbBack (event) {
        document.addEventListener("mousemove", mouseMoveScrollThumbBack, true);
        document.addEventListener("mouseup", mouseUpScrollThumbBack, true);
        thumbStartY = event.y;
        scrollThumbStartPos = parseInt(document.defaultView.getComputedStyle(scrollThumbBack,'').getPropertyValue('top'));
                DEBUG("mdThumbHeight:" + thumbHeight + " thumbStartY=" + thumbStartY);
}

function mouseMoveScrollThumbBack (event) {
        var deltaY = event.y - thumbStartY;
        var newPosition = scrollThumbStartPos + deltaY;
                DEBUG("mmst: event.y=" + event.y + " thumbStartY=" + thumbStartY + " thumbStart=" + scrollThumbStartPos);
        scrollContent(newPosition,"back");
}

function scrollContent(newThumbPosition,backOrFront) {
		DEBUG("scrollContent: newPositionIn=" + newThumbPosition);
	if (newThumbPosition < SCROLLBAR_TOP) {
			DEBUG("sc: thumb too high (" + newThumbPosition + ")");
		newThumbPosition = SCROLLBAR_TOP;
	} else if ((newThumbPosition + thumbHeight) > scrollBarHeight) {
			DEBUG("sc: thumb too low (" + newThumbPosition + ")");
		newThumbPosition = scrollBarHeight - thumbHeight;
	}
		DEBUG("scrollContent: newPosition=" + newThumbPosition);
        if(backOrFront=="back"){
		scrollThumbBack.style.top = newThumbPosition + 'px';
			DEBUG("calculating delta");
		currentContentTop = pagePositionForThumbPosition(newThumbPosition);
			DEBUG("scrollContent: thumbTop=" + scrollThumb.style.top + " currentContentTop is " + currentContentTop);
		currentContent.style.top = currentContentTop + 'px';
        } else {
		scrollThumbFront.style.top = newThumbPosition + 'px';
			DEBUG("calculating delta");
		currentContentTop = pagePositionForThumbPosition(newThumbPosition);
			DEBUG("scrollContent: thumbTop=" + scrollThumb.style.top + " currentContentTop is " + currentContentTop);
		currentContent.style.top = currentContentTop + 'px';
	}
}

function mouseUpScrollThumb (event) {
                DEBUG("must: eventY=" + event.y);
        document.removeEventListener("mousemove", mouseMoveScrollThumb, true);
        document.removeEventListener("mouseup", mouseUpScrollThumb, true);
        thumbStartY = -1;
}

function mouseUpScrollThumbBack (event) {
		DEBUG("must: eventY=" + event.y);
	document.removeEventListener("mousemove", mouseMoveScrollThumbBack, true);
	document.removeEventListener("mouseup", mouseUpScrollThumbBack, true);
	thumbStartY = -1;
}

function mouseDownTrack (event) {
	updateTrackMouseY(event);
	document.getElementById(SCROLLTRACK_DIV_NAME).addEventListener("mousemove", mouseMoveTrack, false);
	document.getElementById(SCROLLTRACK_DIV_NAME).addEventListener("mouseover", mouseOverTrack, false);
	document.getElementById(SCROLLTRACK_DIV_NAME).addEventListener("mouseout", mouseOutTrack, false);
	var thumbTop = document.defaultView.getComputedStyle(scrollThumb,'').getPropertyValue('top');
		DEBUG("trackClick: mouseY=" + trackMouseY + " scrollThumbY=" + thumbTop);
	if (trackMouseY > parseInt(thumbTop)) {
			DEBUG("click BELOW thumb ");
		pageDown();
		trackTimer = setInterval("pageDown();", 150);
	} else {
			DEBUG("click ABOVE thumb");
		pageUp();
		trackTimer = setInterval("pageUp();", 150);
	}
	DEBUG("mdt: newPosition=" + trackMouseY);
}

function mouseMoveTrack(event) {
	updateTrackMouseY(event);
}

function mouseOutTrack(event) {
	tracking = false;
}

function mouseOverTrack(event) {
	tracking = true;
}

function mouseUpTrack(event) {
	clearInterval(trackTimer);
	document.getElementById(SCROLLTRACK_DIV_NAME).removeEventListener("mousemove", mouseMoveTrack, false);
	document.getElementById(SCROLLTRACK_DIV_NAME).removeEventListener("mouseover", mouseMoveTrack, false);
	document.getElementById(SCROLLTRACK_DIV_NAME).removeEventListener("mouseout", mouseMoveTrack, false);
}


function mouseDownTrackBack (event) {
        updateTrackMouseY(event);
        document.getElementById(SCROLLTRACK_DIV_NAME).addEventListener("mousemove", mouseMoveTrack, false);
        document.getElementById(SCROLLTRACK_DIV_NAME).addEventListener("mouseover", mouseOverTrack, false);
        document.getElementById(SCROLLTRACK_DIV_NAME).addEventListener("mouseout", mouseOutTrack, false);
        var thumbTop = document.defaultView.getComputedStyle(scrollThumb,'').getPropertyValue('top');
                DEBUG("trackClick: mouseY=" + trackMouseY + " scrollThumbY=" + thumbTop);
        if (trackMouseY > parseInt(thumbTop)) {
                        DEBUG("click BELOW thumb ");
                pageDown();
                trackTimer = setInterval("pageDown();", 150);
        } else {
                        DEBUG("click ABOVE thumb");
                pageUp();
                trackTimer = setInterval("pageUp();", 150);
        }
        DEBUG("mdt: newPosition=" + trackMouseY);
}

function mouseMoveTrackBack(event) {
        updateTrackMouseY(event);
}

function mouseOutTrack(event) {
        tracking = false;
}

function mouseOverTrack(event) {
        tracking = true;
}

function mouseUpTrack(event) {
        clearInterval(trackTimer);
        document.getElementById(SCROLLTRACK_DIV_NAME).removeEventListener("mousemove", mouseMoveTrack, false);
        document.getElementById(SCROLLTRACK_DIV_NAME).removeEventListener("mouseover", mouseMoveTrack, false);
        document.getElementById(SCROLLTRACK_DIV_NAME).removeEventListener("mouseout", mouseMoveTrack, false);
}


function updateTrackMouseY (event) {
		DEBUG("utmY: source=" + event.toElement.id + " offsetY=" + event.offsetY + " layerY=" + event.layerY + " offsetTop=" + event.toElement.offsetTop);
	if (event.toElement.id == 'myScrollTrackMid') {
		var topHeight = document.defaultView.getComputedStyle(document.getElementById(TRACK_TOP_DIV_NAME)).getPropertyValue('height');
		trackMouseY = event.offsetY + parseInt(topHeight);
			DEBUG("utmY: click in mid, topHeight=" + topHeight);
	} else if (event.toElement.id == TRACK_BOT_DIV_NAME) {
		var midHeight = document.defaultView.getComputedStyle(document.getElementById(TRACK_MID_DIV_NAME)).getPropertyValue('height');
		var topHeight = document.defaultView.getComputedStyle(document.getElementById(TRACK_TOP_DIV_NAME)).getPropertyValue('height');
		trackMouseY = event.offsetY + parseInt(midHeight) + parseInt(topHeight);
			DEBUG("utmY: click in bottom, offsetY=" + event.offsetY + " offsetTop=" + event.toElement.offsetTop + " mid+top=" + (parseInt(midHeight) + parseInt(topHeight)));
	} else {
			DEBUG("utmY: click in top, offsetY=" + event.offsetY + " offsetTop=" + event.toElement.offsetTop + " parentTop=" + event.toElement.parentNode.offsetTop);
		trackMouseY = event.offsetY - (event.toElement.offsetTop + event.toElement.parentNode.offsetTop);
	}	
		DEBUG("utmY: trackMouseY" + trackMouseY);
}

function pageDown() {
	if (!tracking) return;
	currentContentTop = parseInt(currentContentStyle.getPropertyValue('top'));
	var lastPageY = -(currentContentHeight - viewHeight);
	var nextPageY = currentContentTop - viewHeight;
		DEBUG("pageDown: currentContent.lastPageY=" + lastPageY + " nextPageY=" + nextPageY);
	currentContentTop = Math.max(lastPageY, nextPageY);
	currentContent.style.top = currentContentTop + 'px';
	var newThumbTop = thumbPositionForPagePosition(currentContentTop);
	var thumbBottom = newThumbTop + parseInt(scrollThumb.style.height);
	scrollThumb.style.top = newThumbTop;
		DEBUG("pageDown: currentContentTop=" + currentContentTop + " currentContentHeight=" + currentContentHeight + " newThumbTop=" + newThumbTop + " thumbBottom=" + thumbBottom);
	if (trackMouseY < thumbBottom) {
		clearInterval(trackTimer);
	}
}

function pageUp() {
	if (!tracking) return;
	currentContentTop = parseInt(currentContentStyle.getPropertyValue('top'));
	var firstPageY = 0;
	var nextPageY = currentContentTop + viewHeight;
	currentContentTop = Math.min(firstPageY, nextPageY)
	currentContent.style.top = currentContentTop + 'px';
	var newThumbTop = thumbPositionForPagePosition(currentContentTop);
		DEBUG("pageUp: contentTop=" + currentContentTop + " newThumbTop=" + newThumbTop);// + " thumbBottom=" + thumbBottom);
	scrollThumb.style.top = newThumbTop;

	if (trackMouseY > newThumbTop) {
		clearInterval(trackTimer);
	}
}

function getProportion (viewheight, documentheight) {
	if ((documentheight <= viewheight) || (documentheight==0) || (viewheight==0))
		return 0;
	else
		return viewheight/documentheight;
}

function pagePositionForThumbPosition (thumbPosition) {
	return -(thumbPosition - SCROLLBAR_TOP) * ((currentContentHeight - viewHeight) / numberOfScrollablePixels);
}

function thumbPositionForPagePosition (pagePosition) {
	return -(pagePosition / ((currentContentHeight - viewHeight) / numberOfScrollablePixels)) + SCROLLBAR_TOP;
}

var debugMode = false;

function DEBUG(str) {
	if (debugMode) {
		if (window.widget) {
			alert(str);
		} else {
			document.getElementById('debugDiv').innerHTML += str + "<br>";
		}
	}
}

function toggleDebug() {
	debugMode = !debugMode;
	if (debugMode == true) {
		document.getElementById('debugDiv').style.display = 'block';
	} else {
		document.getElementById('debugDiv').style.display = 'none';
	}
}
function openJiwire(index)
{ 
  widget.openURL(urls[index]);
}
function getVersionUpdateLink(){
  xml_request = new XMLHttpRequest();

  xml_request.onreadystatechange = processVersionUpdateChange;
  // asyncronous request
  // using POST because GET had unpredicatable results...
  xml_request.open("POST", "http://www.jiwire.com/apple-widget-updates.htm", true);
  xml_request.send(null);

}
 
function processVersionUpdateChange(){
  if( xml_request.readyState == 4) {
    if( xml_request.status == 200) {
      var update = xml_request.responseXML.getElementsByTagName("update");
      var version = getElementTextNS("", "update_version", update[0], 0);
      var blurb = getElementTextNS("", "update_blurb", update[0], 0);
      var url = getElementTextNS("", "update_url", update[0], 0);
      var html="";
      if(version>VERSION){
        html='<a href="javascript:widget.openURL(\''+url+'\');" class="w211_link" target="_blank">'+blurb+'</a>';
      }
      document.getElementById("w211_text_update").innerHTML=html;
    } 
  }
}     

